
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

import org.codehaus.jackson.map.ObjectMapper;
import org.hornetq.api.core.HornetQException;
import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.core.client.ClientMessage;
import org.hornetq.api.core.client.ClientProducer;
import org.hornetq.api.core.client.ClientSession;
import org.hornetq.api.core.client.ClientSessionFactory;
import org.hornetq.api.core.client.HornetQClient;
import org.hornetq.api.core.client.ServerLocator;
import org.hornetq.core.config.Configuration;
import org.hornetq.core.config.impl.ConfigurationImpl;
import org.hornetq.core.remoting.impl.invm.InVMAcceptorFactory;
import org.hornetq.core.remoting.impl.invm.InVMConnectorFactory;
import org.hornetq.core.remoting.impl.netty.NettyAcceptorFactory;
import org.hornetq.core.remoting.impl.netty.NettyConnectorFactory;
import org.hornetq.core.server.HornetQServer;
import org.hornetq.core.server.HornetQServers;
import org.hornetq.core.server.embedded.EmbeddedHornetQ;
import org.zeromq.ZMQ;

public class hqtestserver {

	/**
	 * @param args
	 */
	public static void main(String[] args) 
	{

		ClientSession session = null;
		ClientProducer producer = null;
		ClientSession coreSession = null;
		ClientSessionFactory sf = null;
		ServerLocator serverLocator = null;
		final String queueName = "queue.exampleQueue";
		  
		System.out.println("INIT HORNETQ");
        HashMap<String, Object> map = new HashMap<String, Object>();
        map.put("host", "192.168.20.150");
        map.put("port", 8989);
        
		try {
			
	        Configuration configuration = new ConfigurationImpl();
	        configuration.setPersistenceEnabled(false);
	        configuration.setSecurityEnabled(false);
	        HashSet<TransportConfiguration> transports = new HashSet<TransportConfiguration>();
	        transports.add(new TransportConfiguration(NettyAcceptorFactory.class.getName(),map));
	        //transports.add(new TransportConfiguration(InVMAcceptorFactory.class.getName()));
	        configuration.setAcceptorConfigurations(transports);	        
	        
	        
	        EmbeddedHornetQ embedded = new EmbeddedHornetQ();
	        embedded.setConfiguration(configuration);
	        embedded.start();

	        //serverLocator = HornetQClient.createServerLocatorWithoutHA(new TransportConfiguration(InVMConnectorFactory.class.getName()));
	        serverLocator = HornetQClient.createServerLocatorWithoutHA(new TransportConfiguration(NettyConnectorFactory.class.getName(),map));
	        serverLocator.setConnectionTTL(-1);
	        serverLocator.setClientFailureCheckPeriod(-1);
	        
	        
	        sf = serverLocator.createSessionFactory();
	        coreSession = sf.createSession(true,true,0);
	        
	        /*
	        coreSession.createQueue(queueName, queueName, false);
	        producer = coreSession.createProducer(queueName);
			*/
	        

	        //ClientSession coreSession = sf.createSession(false, false, false);
	        coreSession.createQueue(queueName, queueName, false);
	        coreSession.close();
	        sf.close();
	        serverLocator.close();
	        
	        
	        	   
	        /*
            session = sf.createSession(true,true,0);
            producer = session.createProducer(queueName);
           */
		} catch (Exception e) {
			e.printStackTrace();
		}

        System.out.println("INIT ZMQ");
        ZMQ.Context context = ZMQ.context(1);
        ZMQ.Socket sub = context.socket(ZMQ.SUB);
        sub.setIdentity("fssub".getBytes());
        sub.subscribe("".getBytes());
        sub.connect("tcp://192.168.20.73:5556");
        
        while(true) {
        	String Event_Name = "";
        	String Event_Subclass = "";
        	String CC_Agent = "";
        	String CC_Action = "";
        	Long Event_Timestamp = 0L;
        	Long Event_Sequence = 0L;
        	
        	// wait for messages over ZMQ
        	byte[] m = sub.recv(0);
        	Map<String,Object> fsevent = getMessageMap(m);
   
        	try {
    			Event_Name = fsevent.get("Event-Name").toString();
    			if(!Event_Name.equals("CUSTOM"))
    				continue;
    			
    			Event_Subclass = fsevent.get("Event-Subclass").toString();
    			if(!Event_Subclass.equals("callcenter::info"))
    				continue;
    			
    			Event_Timestamp = Long.parseLong(fsevent.get("Event-Date-Timestamp").toString());
    			Event_Sequence = Long.parseLong(fsevent.get("Event-Sequence").toString());
    			CC_Agent = fsevent.get("CC-Agent").toString();
    			CC_Action = fsevent.get("CC-Action").toString();
    			
        	} catch (NullPointerException e) {
        		// ignore
        	} catch (Exception e) {
        		e.printStackTrace();
        	}
        	System.out.println("EVENT# "+Event_Sequence+" , NAME: "+Event_Name+" , TS: "+Event_Timestamp+" , AGENT: "+CC_Agent+" , ACTION: "+CC_Action);

        	
        	// send to hq
        	try {
    	        serverLocator = HornetQClient.createServerLocatorWithoutHA(new TransportConfiguration(NettyConnectorFactory.class.getName(),map));
    	        serverLocator.setConnectionTTL(-1);
    	        serverLocator.setClientFailureCheckPeriod(-1);
    		
        		sf = serverLocator.createSessionFactory();
                session = sf.createSession(true,true,0);
                producer = session.createProducer(queueName);
            	ClientMessage message = session.createMessage(false);
            	message.putBytesProperty("zmq", m);
            	message.setTimestamp(Event_Timestamp);
            	message.setExpiration(System.currentTimeMillis() + 5000);
            	
            	message.putLongProperty("EventSequence", Event_Sequence);
            	message.putStringProperty("CCAgent", CC_Agent);
        		producer.send(message);
        		
        		producer.close();
        		session.close();
        		sf.close();
        		serverLocator.close();
        	} catch (HornetQException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}


        }

	}
	
	public static Map<String,Object> getMessageMap(byte[] message)
	{
		try {
			ObjectMapper mapper = new ObjectMapper();
			@SuppressWarnings("unchecked")
			Map<String,Object> userData = mapper.readValue(message, Map.class);
			return userData;
		} catch (Exception e) {
			e.printStackTrace();	
        }
		return null;
	}
}
